#!/bin/sh

####################################################################################################
#
#   This shell-script comes from the "Zoom Downloader" plugin for Enigma2 set-top boxes
#   Shell-script was modified by s3n0
#   Last change :    2024-08-04
#
####################################################################################################
#
# - you could place this shell script, e.g. to folder:
#       /usr/script
#
# - configuration line for the CRON service, to run the shell-script every 24 hours, because C-LINE is only valid for 24 hours:
#       # update the C-LINE for free CCCAM-server... for testing purposes only... every day, at 04:00
#       00 04 * * *        /bin/sh /usr/script/tichestart1_funkcne_cccam.sh
#
# - please do not forget to add execution attributes:
#       chmod a+x /usr/script/tichestart1_funkcne_cccam.sh
#
# - restart the CRON service - for OpenATV:
#       /etc/init.d/crond restart
#
# - restart the CRON service - for OpenPLi:
#       /etc/init.d/busybox-cron restart
#
####################################################################################################
#
#  CCCAM WARNING:
#
#     The old entries of "dream4" in the form of 3 lines of "CCcam.cfg" will be deleted !
#     At the end of the file, 3 new entries for "dream4" will be added.
#     If you use any other/own C-LINE(s), never add them at the end of file - i.e. after the "dream4" entries !
#     Take care of it !
#
#  OSCAM WARNING:
#
#     The last 12 lines from the end of the "oscam.server" config file will always be deleted,
#     therefore it must be placed really at the end of the file "oscam.server" !
#
#     It is also necessary TO MODIFY the newly created entry for the Oscam configuration file
#     at the end of the file as needed by the user (change the appropriate group, CAID, etc.) !
#     Take care of it !
#
####################################################################################################

CCCAM_CFG="/etc/CCcam.cfg"

OSCAM_SERVER="/etc/tuxbox/config/oscam/oscam.server"

mkdir -p /tmp/xtest
rm -rf /tmp/xtest/*
touch /tmp/xtest/suborik
cd /tmp/xtest

#######################################  dream4ever  ###############################################

curl --limit-rate 100K -s -k -Lbk -A -k -m 8 -m 52 "http://dream4evertwo.info/index.php?pages/D4E/" > /tmp/xtest/CCcam

sed -ne 's#.*HOST:\([^/]*\).*#\1#p' CCcam > adresa
sed -ne 's#.*">\([^/]*\).*#\1#p' adresa > adresa1
sed -i 's/<//' adresa1
sed -i 's/-.*//' adresa1

sed -ne 's#.*PORT:.*>\(.*\)</span></strong>.*#\1#p' CCcam > port
cat port | tr -dc '0-9\n' > port1                       # take numbers only (from whole string)

sed -ne 's#.*USER:\([^/]*\).*#\1#p' CCcam > user
sed -ne 's#.*">\([^/]*\).*#\1#p' user > user1
sed -i 's/<//' user1
#sed -i 's/remove the star//' user1
#sed -i 's/-//' user1
#sed -i 's/*//' user1

sed -ne 's#.*PASS:\([^/]*\).*#\1#p' CCcam > pass
sed -ne 's#.*">\([^/]*\).*#\1#p' pass > pass1
sed -i 's/<//' pass1

echo "C: "  > hotovo
sed -n '1,1p' adresa1 >> hotovo
echo -n " "  >> hotovo
sed -n '1,1p' port1 >> hotovo
echo -n " "  >> hotovo
sed -n '1,1p' user1 >> hotovo
echo -n " "  >> hotovo
sed -n '1,1p' pass1 >> hotovo
sed -n 'H; $x; $s/\n//gp' hotovo > hotovo1
echo "C: "  > hotovo
sed -n '2,2p' adresa1 >> hotovo
echo -n " "  >> hotovo
sed -n '2,2p' port1 >> hotovo
echo -n " "  >> hotovo
sed -n '2,2p' user1 >> hotovo
echo -n " "  >> hotovo
sed -n '2,2p' pass1 >> hotovo
sed -n 'H; $x; $s/\n//gp' hotovo > hotovo2
echo "C: "  > hotovo
sed -n '3,3p' adresa1 >> hotovo
echo -n " "  >> hotovo
sed -n '3,3p' port1 >> hotovo
echo -n " "  >> hotovo
sed -n '3,3p' user1 >> hotovo
echo -n " "  >> hotovo
sed -n '3,3p' pass1 >> hotovo
sed -n 'H; $x; $s/\n//gp' hotovo > hotovo3

cat hotovo1 hotovo2 hotovo3 > ok
sed -i 's/    / /' ok
sed -i 's/*//' ok

grep -o -i -E 'C: [a-z][^<]*' ok  >> /tmp/xtest/suborik

####################################################################################################

if [ -f $CCCAM_CFG ]; then
    sed -i '/dream4ever/d' $CCCAM_CFG           # delete old entries "dream4ever"
    cat /tmp/xtest/suborik >> $CCCAM_CFG        # add new C-LINE(s) to CCcam.cfg
fi

#############

if [ -f $OSCAM_SERVER ]; then
    
    if cat $OSCAM_SERVER | grep "dream4" > /dev/null
        then head -n -12 ${OSCAM_SERVER} > ${OSCAM_SERVER}_temp     # remove 12 lines from the end of the "oscam.server" file if the old "dream4" entries are still there
        else cp ${OSCAM_SERVER} ${OSCAM_SERVER}_temp
    fi
    
    C_LINE=`cat /tmp/xtest/suborik | grep dream4 | tail -n 1 | tr "C:" " "`
    printf "[reader]
label                 = cardsharing_dream4ever
description           = dream4ever
protocol              = cccam
device                = %s,%s
user                  = %s
password              = %s
cccversion            = 2.0.11
audisabled            = 1
ccckeepalive          = 1
services              = %cskylink_sk_digital,%cskylink_sk_digital_unofficially
group                 = 1
" $C_LINE ! ! >> ${OSCAM_SERVER}_temp
    
    mv -f ${OSCAM_SERVER}_temp ${OSCAM_SERVER}
    /etc/init.d/softcam restart
fi

####################################################################################################

cd /tmp
rm -rf /tmp/xtest
exit
